/*
 * grader-io - grtp.h
 *
 * Copyright (C) 2016  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifndef GRTP_H_INCLUDED
#define GRTP_H_INCLUDED

#include <kernel-types.h>

#define GRTP_PAYLOAD_LEN	6
#define GRTP_FRAME_LEN		10
#define GRTP_SYNC		0x80

#define GRTP_CHECKSUM_INIT	0x3fff
#define GRTP_CHECKSUM_CHECK	0x3c90

struct tty_struct;
struct tty_struct *grtp_init(struct tty_struct *tty,
		void (*callback)(struct tty_struct *tty, const u32 *frame));

int grtp_xmit(struct tty_struct *tty, const unsigned char *frame);
void grtp_poll(struct tty_struct *tty);

#endif
