/*
 * grader - p-sched.h
 *
 * Copyright (C) 2017  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifndef PSCHED_INCLUDED
#define PSCHED_INCLUDED

int pevent_schedule(unsigned int t, unsigned int pos,
		unsigned int *en, unsigned int *sync);

int pevent_start(unsigned int id, unsigned int value);
int pevent_start_after(unsigned int id, unsigned int value,
		unsigned int t, unsigned int pos);
int pevent_adjust(unsigned int id, int delta);
int pevent_adjust_phase(unsigned int id, int delta);
int pevent_set_period(unsigned int id, unsigned int period);
int pevent_get_period(unsigned int id, unsigned int *period);
int pevent_set_period_n(unsigned int id, unsigned int n);
int pevent_get_period_n(unsigned int id, unsigned int *n);
int pevent_set_period_d(unsigned int id, unsigned int d);
int pevent_get_period_d(unsigned int id, unsigned int *d);
int pevent_set_time_period(unsigned int id, unsigned int period);
int pevent_get_time_period(unsigned int id, unsigned int *period);
int pevent_set_setup_time(unsigned int id, unsigned int t);
int pevent_get_setup_time(unsigned int id, unsigned int *t);
int pevent_set_hold_time(unsigned int id, unsigned int t);
int pevent_get_hold_time(unsigned int id, unsigned int *t);
int pevent_set_sync_time(unsigned int id, unsigned int t);
int pevent_get_sync_time(unsigned int id, unsigned int *t);
int pevent_set_backoff_time(unsigned int id, unsigned int t);
int pevent_get_backoff_time(unsigned int id, unsigned int *t);
int pevent_set_mode(unsigned int id, unsigned int mode);
int pevent_get_mode(unsigned int id, unsigned int *mode);

#endif
