/*
 * grader-io - head.S
 *
 * Copyright (C) 2016  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

	.syntax unified
	.thumb
	.code	16
	.sect .vectors, #alloc
	.extern	__stack
	.extern	uart0_irq_handler
	.long	__stack		/* 0x00 Stack */
	.long	_c_int00	/* 0x04 RESET */
	.long	_nmi_handler	/* 0x08 NMI */
	.long	_hfault_handler	/* 0x0c HardFault */
	.long	0		/* 0x10 Reserved */
	.long	0		/* 0x14 Reserved */
	.long	0		/* 0x18 Reserved */
	.long	0		/* 0x1c Reserved */
	.long	0		/* 0x20 Reserved */
	.long	0		/* 0x24 Reserved */
	.long	0		/* 0x28 Reserved */
	.long	_svc		/* 0x2c SVC - Supervisor Calls */
	.long	0		/* 0x30 Reserved */
	.long	0		/* 0x34 Reserved */
	.long	_bad_interrupt	/* 0x38 Pend SV */
	.long	_bad_interrupt	/* 0x3c SysTick */
	.long	_bad_interrupt	/* 0x40 IRQ0 */
	.long	_bad_interrupt	/* 0x44 IRQ1 */
	.long	_bad_interrupt	/* 0x48 IRQ2 */
	.long	_bad_interrupt	/* 0x4c IRQ3 */
	.long	_bad_interrupt	/* 0x50 IRQ4 */
	.long	uart0_irq_handler	/* 0x54 IRQ5 */
	.long	uart1_irq_handler	/* 0x58 IRQ6 */
	.long	uart2_irq_handler	/* 0x5c IRQ7 */
	.long	uart3_irq_handler	/* 0x60 IRQ8 */
	.long	_bad_interrupt	/* 0x64 IRQ9 */
	.long	_bad_interrupt	/* 0x68 IRQ10 */
	.long	_bad_interrupt	/* 0x6c IRQ11 */
	.long	_bad_interrupt	/* 0x70 IRQ12 */
	.long	_bad_interrupt	/* 0x74 IRQ13 */
	.long	_bad_interrupt	/* 0x78 IRQ14 */
	.long	_bad_interrupt	/* 0x7c IRQ15 */
	.long	_bad_interrupt	/* 0x80 IRQ16 */
	.long	_bad_interrupt	/* 0x84 IRQ17 */
	.long	_bad_interrupt	/* 0x88 IRQ18 */
	.long	_bad_interrupt	/* 0x8c IRQ19 */
	.long	_bad_interrupt	/* 0x90 IRQ20 */
	.long	_bad_interrupt	/* 0x94 IRQ21 */
	.long	_bad_interrupt	/* 0x98 IRQ22 */
	.long	_bad_interrupt	/* 0x9c IRQ23 */
	.long	_bad_interrupt	/* 0xa0 IRQ24 */
	.long	_bad_interrupt	/* 0xa4 IRQ25 */
	.long	_bad_interrupt	/* 0xa8 IRQ26 */
	.long	_bad_interrupt	/* 0xac IRQ27 */
	.long	_bad_interrupt	/* 0xb0 IRQ28 */
	.long	_bad_interrupt	/* 0xb4 IRQ29 */
	.long	_bad_interrupt	/* 0xb8 IRQ30 */
	.long	_bad_interrupt	/* 0xbc IRQ31 */

	.sect .init
	.thumb_func
	.globl _c_int00;
_c_int00:
	/* clear SRAM */
	movs	r3, #1
	movs	r1, #0
	lsls	r2, r3, #15	/* 0x00008000 */
	lsls	r3, r3, #28	/* 0x10000000 */
	add	r2, r3, r2
1:
	stmia	r3!, {r1}
	cmp	r3, r2
	bne	1b

	b	start_kernel

	.thumb_func
_nmi_handler:
	.thumb_func
_hfault_handler:
	.thumb_func
_svc:
	.thumb_func
_bad_interrupt:
	b	_bad_interrupt
