/*
 * grader-io - posix-timer.c
 *
 * Copyright (C) 2017  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <kernel.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

void timer_init(void)
{
}

unsigned int gettime(void)
{
	static unsigned long long prev_t;
	static unsigned long jiffies;
	struct timespec ts;
	unsigned long long t;
	unsigned long long delta;
	int ret;

	ret = clock_gettime(CLOCK_MONOTONIC, &ts);
	if (ret < 0)
		return 0;
	t = (unsigned long long)(1000000000ULL * ts.tv_sec + ts.tv_nsec);
	delta = t - prev_t;
	delta /= 10;
	prev_t += 10 * delta;
	jiffies += delta;
	return (uint32_t) jiffies;
}
